import java.awt.*;
import java.applet.*;
public class worldTest
{
    /*________________________________
    ___________Variable_____________*/
    //functor
    pigFunc pig = new pigFunc();
    //worldFunc w = new worldFunc();
    atomFunc a = new atomFunc();
    vectorFunc v = new vectorFunc();
    entityFunc e = new entityFunc();
    //constant
    int maxAtoms = 300;                             // max atom allowed
    //double deltaT = 0.001d;                         // physics frame lenght
    double deltaT = 0.5;                         // physics frame lenght
    
    world U = new world(new vector(570,295), 240);
    entity test = new entity(new atom[0], 0);
    entity rocket = new entity(new atom[0], 0);
    
    Boolean throttle =false,
            turnLeft = false,
            turnRight = false;
    
    /*________________________________
    ___________Initialisation_______*/
    public void initialize() 
    {
        rocket = e.addAtom(rocket, new atom(400,160, 0, 13, 30, 10, 0.99, 30));
        rocket = e.addAtom(rocket, new atom(393,177, 1, 13, 30, 7, 0.9, 30));
        rocket = e.addAtom(rocket, new atom(407,177, 2, 13, 30, 7, 0.9, 30));
        rocket = e.linkAtom( rocket, 0,1,20);
        rocket = e.linkAtom( rocket, 0,2,20);
        rocket = e.linkAtom( rocket, 1,2,16);
    
        for (int i=0;i<maxAtoms;i++)
        {
            test = e.addAtom(test, new atom(640, 440, i, 4,2, 5, 0.6, 30));
        }


    }
    /*________________________________
    ___________Main Loop____________*/
    
    public void up(Boolean s)
    {
        throttle = s;
    }
    
    public void left(Boolean s)
    {
        turnLeft = s;
    }
    
    public void right(Boolean s)
    {
        turnRight = s;
    }
    
    public void loop()
    {
        for(float d=0;d<1;d+=deltaT)
        {
            if (throttle)
            {
                vector direction = v.add(v.sub(rocket.atomPool[0].pos,rocket.atomPool[1].pos), v.sub(rocket.atomPool[0].pos,rocket.atomPool[2].pos));
                rocket.atomPool[1] = a.addforce(rocket.atomPool[1], v.scale(direction,2.9));
                rocket.atomPool[2] = a.addforce(rocket.atomPool[2], v.scale(direction,2.9));
            }
            if (turnLeft)
            {
                vector direction = v.add(v.sub(rocket.atomPool[0].pos,rocket.atomPool[1].pos), v.sub(rocket.atomPool[0].pos,rocket.atomPool[2].pos));
                rocket.atomPool[1] = a.addforce(rocket.atomPool[1], v.scale(direction, 2.9));
            }
            if (turnRight)
            {
                vector direction = v.add(v.sub(rocket.atomPool[0].pos,rocket.atomPool[1].pos), v.sub(rocket.atomPool[0].pos,rocket.atomPool[2].pos));
                rocket.atomPool[2] = a.addforce(rocket.atomPool[2], v.scale(direction, 2.9));
            }
        
            functorAtomForce processAtomForce[] = new functorAtomForce[2];
            //process interatom force
            //Map
            processAtomForce[0] = new functorAtomForce(test.atomPool, 0, test.atomQty, test);
            processAtomForce[1] = new functorAtomForce(rocket.atomPool, 0, rocket.atomQty, rocket);
            //start 2 thread
            for (int i=0;i<2;i++)
                processAtomForce[i].start();
            //wait
            for (int i=0;i<2;i++)
                try {
                   processAtomForce[i].join();
                } catch (InterruptedException ignore) {}
            //Reduce
            test = new entity(processAtomForce[0].atomDest, processAtomForce[0].end - processAtomForce[0].start);
            rocket = new entity(processAtomForce[1].atomDest, processAtomForce[1].end - processAtomForce[1].start);
            
            //process interatom force inter object (cant do it simultaneously with previous)
            //Map
            processAtomForce[0] = new functorAtomForce(test.atomPool, 0, test.atomQty, rocket);
            processAtomForce[1] = new functorAtomForce(rocket.atomPool, 0, rocket.atomQty, test);
            //start
            for (int i=0;i<2;i++)
                processAtomForce[i].start();
            //wait
            for (int i=0;i<2;i++)
                try {
                   processAtomForce[i].join();
                } catch (InterruptedException ignore) {}
            //Reduce
            test = new entity(processAtomForce[0].atomDest, processAtomForce[0].end - processAtomForce[0].start);
            rocket = new entity(processAtomForce[1].atomDest, processAtomForce[1].end - processAtomForce[1].start);
            
            //Map spring force
            functorSpringForce processSpringForce[] = {new functorSpringForce(test.atomPool, 0, test.atomQty),
                                                       new functorSpringForce(rocket.atomPool, 0, rocket.atomQty)};
            for (int i=0;i<2;i++)
                processSpringForce[i].start();
            for (int i=0;i<2;i++)
                try {
                   processSpringForce[i].join();
                } catch (InterruptedException ignore) {}
            //reduce
            test = new entity(processSpringForce[0].atomDest, processSpringForce[0].end - processSpringForce[0].start);
            rocket = new entity(processSpringForce[1].atomDest, processSpringForce[1].end - processSpringForce[1].start);
            
            //Map world Force
            functorWorld processWorldForce[] = {new functorWorld(U, rocket.atomPool, 0, rocket.atomQty),
                                                new functorWorld(U, test.atomPool, 0, test.atomQty)};
            for (int i=0;i<2;i++)
                processWorldForce[i].start();
            for (int i=0;i<2;i++)
                try {
                   processWorldForce[i].join();
                } catch (InterruptedException ignore) {}
            //Reduce
            rocket = new entity(processWorldForce[0].atomDest, processWorldForce[0].end - processWorldForce[0].start);
            test = new entity(processWorldForce[1].atomDest, processWorldForce[1].end - processWorldForce[1].start);

            //Map Integration
            functorIntegrate processIntegration[] = {new functorIntegrate(rocket.atomPool, 0, rocket.atomQty, deltaT),
                                                     new functorIntegrate(test.atomPool, 0, test.atomQty, deltaT)};
            for (int i=0;i<2;i++)
                processIntegration[i].start();
            for (int i=0;i<2;i++)
                try {
                   processIntegration[i].join();
                } catch (InterruptedException ignore) {}
            //Reduce
            rocket = new entity(processIntegration[0].atomDest, processIntegration[0].end - processIntegration[0].start);
            test = new entity(processIntegration[1].atomDest, processIntegration[1].end - processIntegration[1].start);
        }
    }
    
    /*________________________________
    ___________draw_________________*/
    public void paint (Graphics g) 
    {
        //draw something
        g.setColor(Color.black);
        g.drawLine(400,60,500,60);
        g.drawString("World Test",502,64);

        g.setColor(Color.blue);
        for (int i=0; i<maxAtoms; i++)
        {
            pig.circle(g, test.atomPool[i].pos, test.atomPool[i].radius);
            for (int j=0; j<test.atomPool[i].linkQty;j++)
            {
                pig.line(g, test.atomPool[i].pos, test.atomPool[test.atomPool[i].linkedTo[j]].pos);
            }
        }

        //drawRocketFrame
        g.setColor(Color.black);
        for (int i=0; i<rocket.atomQty;i++)
        {
            pig.circle(g,rocket.atomPool[i].pos, rocket.atomPool[i].radius);
            for (int j=0; j<rocket.atomPool[i].linkQty;j++)
            {
                pig.line(g, rocket.atomPool[i].pos, rocket.atomPool[rocket.atomPool[i].linkedTo[j]].pos);
            }
        }

        
        g.setColor(Color.red);
        pig.circle(g, U.center, (int)U.radius);
    }
}
